[librechroot] In unit tests, ca-certificates post-install fails
2014-02-02 07:42 PM - lukeshu
Priority: bug

Assignee:

Category:

Description

| can't replicate it outside of testenv, but in testenv, the ca-certificates post_install scriptlet (which just runs
usr/bin/update-ca-certificates --fresh) fails:

[luke@thinkpenguin-par test]$ testsudo strace -ff -tt -o strace.out librechroot -n test2 make
[sudo] password for luke:
==> Creating 'root' copy for chroot [test2]
Create subvolume '/var/lib/archbuild/test2/root'
==> Creating install root at /var/lib/archbuild/test2/root
==> Installing packages to /var/lib/archbuild/test2/root
Synchronizing package databases...

(30/91) installing libcap [#E#H4H A HH A HHAFH SR FHHHEHHH] 100
(31/91) installing coreutils [##HHHHHAHFHESHHAFH SR FHHRFHHHH] 100%
(32/91) installing sed [HAE#FHFHHAFFAESHHAFHERF AR FHRHH] 100%
( [ ]

33/91) installing ca-certificates FHHFEFHFHE A F A A F A FHAHFEHF] 100D
error: command failed to execute correctly
(34/91) installing shadow [HHHf A A A4 H] 1008

It looks like the first call to mktemp is failing:

$ grep -1 'execve ("usr/bin/update-ca-certificates",' strace.out.*|xargs grep clonel|sed 's/.* /stra
ce.out./'|xargs grep execve

strace.out.29621:14:14:23.487806 execve ("/usr/bin/mktemp", ["mktemp", "-t", "ca-certificates.crt.t
mp . XXXXXX"], [/* 27 vars */]) =0

strace.out.29622:14:14:23.492452 execve ("/usr/bin/rm", ["rm", "-f", ""], [/* 27 vars */]) =0
strace.out.29623:14:14:23.495894 execve ("/usr/bin/rm", ["rm", "-f", ""], [/* 27 vars */]) =0
strace.out.29624:14:14:23.499166 execve ("/usr/bin/rm", ["rm", "-f", ""], [/* 27 vars */]) =0

My first thought when | saw that is that ca-certificates was being installed before coreutils, but looking at stdout, | verified that that's
not the case. Perhaps it is something to do with testsudo+TMPDIR?

Related issues:
Related to libretools - Bug #487: [librechroot/mkarchroot] Obey proxy settings. fixed 2014-02-03

History

#1 - 2014-02-03 03:51 AM - lukeshu
- Related to Bug #487: [librechroot/mkarchroot] Obey proxy settings. added

#2 - 2014-02-03 03:51 AM - lukeshu

So, pacman with -r calls chroot(2) before spawning each install scriptlet. That means that any environmental variables that reference files, are now
invalid. To work around this, we now wipe the environment before entering pacstrap.

#3 - 2014-02-03 03:51 AM - lukeshu
- Status changed from open to fixed

- % Done changed from 0 to 100
